/*
	Gauztris, a svgalib Tetris-like game for consoles
	Copyright (C) 2001 Brian Mastrobuono <gauze@rifug.org>

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

/* functions 

void draw(void);
void initfield(void);
void swabboard(void);
int score(int);
int get_keys(void);
int new_piece(void);
void rotate_clock(void);
void rotate_counterclock(void);
void gameover(void);
void verify_place(void);
void timer(void);
bool movevalid(void);
void help(void);
void paused(void);
void hiscores(void);
void blockdone(void); 

*/

int score(int lines) /* scoring based on Nintendo GB version */
{
	switch(lines)
	{
		case 1: return( player.level * 40 );
			break;	
		case 2: return( player.level * 100 );
			break;
		case 3: return( player.level * 300 );
			break;
		case 4: return( player.level * 1200 );
			break;
		default: break;
	}
	return(0); 
}

void paused(void)
{
	while(1) 
	{ 
		gl_printf(230,12, "PAUSED");
		if ( keyboard_update() == TRUE )
			if ( keyboard_keypressed(SCANCODE_P) )
			{
				gl_printf(230,12,"      ");
				return;
			}
	}
}

bool movevalid(void) 
{
	int v, h;

	if ( playfield[piece.vert][piece.horiz] == FINISHED_BLOCK ||
		piece.vert > 22 || piece.horiz > 22 || piece.horiz < 0)
		return(FALSE);
		for ( i = 0; i < 3 ; i++ )
		{
			v = piece.vert + piece.shape[piece.shapetype][i][0];
			h = piece.horiz + piece.shape[piece.shapetype][i][1];
			if ( playfield[v][h] == FINISHED_BLOCK ||
				 v > 22 || h > 9 || h < 0 )
						return(FALSE);
		}

		return(TRUE);
}

int new_piece(void)
{
	static int fuck = 0;
	int i, j, k, l;
	if (fuck < 1)
	{
		piece.shapetype = (int) (7.0*rand()/(RAND_MAX+1.0));
		fuck++;
	}
	else 
		piece.shapetype = mynext.shapetype;
	
	mynext.shapetype = ((int)(rand() % 7)); 
	piece.shapenum = 1;
	piece.vert = 1;
	piece.horiz = 4;
	cycle_count = 0;
	baseshapetype = piece.shapetype;
	vga_setcolor(BLACK);
	for ( i = 7; i < 11 ; i++ )
		for ( j = 3; j < 7 ; j++ )
			for ( k = 0 ; k <= SCALE ; k++ )
				for ( l = 0 ; l <= SCALE ; l++ )
					vga_drawpixel(j*SCALE+k, i*SCALE+l); 
	return (mynext.shapetype);
}


void hiscores(void)
{
	int i;
	FILE *hsf;
	if ((hsf = fopen("/var/games/tetris/hiscores", "r")) == NULL)
		gl_printf(23,0,"Cannot Open Hiscore data file for read\n");
	else
	{
		for ( i = 0; i < 10 ; i++ )
			fscanf(hsf, "%d %s", &highscore[i].score, highscore[i].name);

		fclose(hsf);

		if ( player.score > highscore[9].score ) // re-sort Hi scorez
		{
				//char buff[11];
				vga_clear();
				gl_printf(13,10,"You have a highscore! Type your name 8 letters or less plz: ");
				keyboard_clearstate();
			//	fflush(stdin);
	
	/*			insert Hi score info here */
			
 				//temp.name = "foo";
				temp.lines = player.lines;

				highscore[9] = temp;

				for ( i = 8; i >= 0 ; i-- )
						if ( highscore[i+1].score >= highscore[i].score )
						{
								temp = highscore[i];
								highscore[i]= highscore[i+1];
								highscore[i+1] = temp;
						}
		}

		if ((hsf = fopen("/var/games/tetris/hiscores", "w")) == NULL)
		{
			vga_clear();
			gl_printf(23,0,"Cannot Open Hiscore data file for write\n");
		}
		else
			for ( i = 0; i < 10 ; i++ )
				fprintf(hsf,"%d %s\n", highscore[i].score, highscore[i].name);
		fclose(hsf);

		vga_clear();
		gl_printf(0,0, "HIGH SCORES"); // doesn't need animation
		for ( i = 0; i < 10 ; i++ )
		{
				gl_printf(10,(i+1)*10,"%s" , highscore[i].name);
				gl_printf(100-(int)(log10((double)highscore[i].score)), (i+1)*10,"%d", highscore[i].score);
		}
		sleep(5);
/*
		for ( j = 0; j < 25 ; j++ )
		{
				for (i = 0; i < 18 ; i++)
				{
						mvprintw(7,i+OFFSET,"%c",ACS_CKBOARD);
						mvprintw(9,i+OFFSET,"%c",ACS_CKBOARD);
						mvprintw(20,i+OFFSET,"%c",ACS_CKBOARD);
				}
				for ( i = 0 ; i < 14 ; i++ )
				{
						mvprintw(7+i,OFFSET,"%c",ACS_CKBOARD);
						mvprintw(7+i,OFFSET+18,"%c", ACS_CKBOARD);
				}
				usleep(100000);
				for (i = 0; i < 18 ; i++)
				{
						mvprintw(7,i+OFFSET,"%c",ACS_BOARD);
						mvprintw(9,i+OFFSET,"%c",ACS_BOARD);
						mvprintw(20,i+OFFSET,"%c",ACS_BOARD);
				}
				for ( i = 0 ; i < 14 ; i++ )
				{
						mvprintw(7+i,OFFSET,"%c",ACS_BOARD);
						mvprintw(7+i,OFFSET+18,"%c", ACS_BOARD);
				}
				usleep(100000); 
		} */

		}
}




void timer(void) 
{
			/*	timer section  must fix this sucks!*/
				usleep(50000/player.level); // make a real timer at some point.

				if ( cycle_count > 9 )
				{
					piece.vert++;
					GOINGDOWN = TRUE;
					if ( !movevalid() )
					{
							piece.vert--;
							AT_BOTTOM = TRUE;
					}
					cycle_count = 0;
				}
}


void verify_place(void)
{
				/* kill old position */
	for ( i = 0; i < 3 ; i++ )
	{
		playfield
			[(oldposvert + piece.shape[oldshapetype][i][0])]								[(oldposhoriz + piece.shape[oldshapetype][i][1])]								= NO_BLOCK;
	}
	playfield[oldposvert][oldposhoriz] = NO_BLOCK;

	for ( i = 0; i < 3 ; i++ ) // block done?
	{
		if ( playfield
		   [(piece.vert  + piece.shape[piece.shapetype][i][0])]
		   [(piece.horiz + piece.shape[piece.shapetype][i][1])]
		   == FINISHED_BLOCK && GOINGDOWN)
		{
			AT_BOTTOM=TRUE;
			return;
		} 
			
	}
	if ( playfield[piece.vert][piece.horiz] == FINISHED_BLOCK )
	{
		AT_BOTTOM=TRUE;
		return;
	}

		/* set new position and erase one above unless finished*/
	for ( i = 0; i < 3 ; i++ )
	{
		if ( piece.vert > 2 && 
			 playfield[((piece.vert-1) + 
			 piece.shape[piece.shapetype][i][0])]
			[(piece.horiz + piece.shape[piece.shapetype][i][1])] 
			!= FINISHED_BLOCK )
		playfield
				[((piece.vert-1)  + piece.shape[piece.shapetype][i][0])]
				[(piece.horiz + piece.shape[piece.shapetype][i][1])]
				= NO_BLOCK;
	}

	if ( piece.vert > 2 && playfield[piece.vert-1][0] != FINISHED_BLOCK )
		playfield[(piece.vert-1)][piece.horiz] = NO_BLOCK;


  /* previous was for old position ... */
	for ( i = 0; i < 3 ; i++ )
	{
		playfield
		[(piece.vert  + piece.shape[piece.shapetype][i][0])]
		[(piece.horiz + piece.shape[piece.shapetype][i][1])]
		= BLOCK;
	}
	playfield[piece.vert][piece.horiz] = BLOCK;
	/* end of testing and/or placing piece */
	
	GOINGDOWN = FALSE; // reset for next move ...
}


void swabboard(void) 
{
	int i, j, k, l;
	int lines_this_drop = 0, line_to_kill=0;
	bool FILLED;
	beep_parms_t mybeep;

	for ( i = 3 ; i < 24 ; i++ )
	{
		FILLED = TRUE;
		for ( j = 0; j < 10 ; j++ )	
		{
			if ( playfield[i][j] != FINISHED_BLOCK )
			{
				FILLED = FALSE;
				break;
			}
			line_to_kill = i;
		}
		if ( FILLED == TRUE )	
		{	
			/* eye candy routine finished lines flash */ 
			for ( l = 0 ; l < 3 ; l++ )
			{
				for ( i = 0 ; i < 10 ; i++ )
					for ( j = 0; j <= SCALE ; j++ )
						for ( k = 0; k <= SCALE ; k++ )
				{
					vga_setcolor(BLACK);
					vga_drawpixel((OFFSET+i)*SCALE+j,line_to_kill*SCALE+k);
				}
				mybeep = (beep_parms_t) { NOTE_B, 1, THIRTYSECOND_NOTE, 120 };
				play_beep(mybeep);
				
				for ( i = 0 ; i < 10 ; i++ )
					for ( j = 0; j <= SCALE ; j++ )
						for ( k = 0; k <= SCALE ; k++ )
				{
					vga_setcolor(WHITE);
					vga_drawpixel((OFFSET+i)*SCALE+j,line_to_kill*SCALE+k);
				}
				mybeep = (beep_parms_t) { NOTE_A, 1, THIRTYSECOND_NOTE, 120 };
				play_beep(mybeep);
				
			} 
			
			lines_this_drop++;
			player.lines++;
			for ( i = line_to_kill ; i > 1 ; i-- )
				for ( j = 0 ; j < 10 ; j++ )	
					playfield[i][j] = playfield[i-1][j];
			
			for ( i = 0 ; i < 10 ; i++ )
				playfield[0][i] = ' ';
		}
	}
	player.score += score(lines_this_drop);
	player.level = startlevel + player.lines/10;


	/* testing drawing dropped pieces only once per drop ... */
	/* the pit's contents */
	for ( i = 3; i < 23 ; i++ )
		for ( j = 0 ; j < 10 ; j++ )
			if ( playfield[i][j] == FINISHED_BLOCK )
			{
				for ( k = 0 ; k <= SCALE ; k++ )
					for ( l = 0 ; l <= SCALE ; l++ )
						vga_drawpixel( (j+OFFSET)*SCALE+k, SCALE*i+l );
			}

}

void blockdone(void)
{
/* entering this any conflicts with overlapping
								blocks should ALREADY BE SOLVED! */
	playfield[oldposvert][oldposhoriz] = FINISHED_BLOCK;

	if (piece.vert < 1)
		PLAYING = FALSE;

	for ( i = 0; i < 3 ; i++ )
	{
		playfield
		 [(oldposvert  + piece.shape[oldshapetype][i][0])]
		 [(oldposhoriz + piece.shape[oldshapetype][i][1])]
		 = FINISHED_BLOCK; // 0 is Y || 1 is X

		if ((oldposvert + piece.shape[oldshapetype][i][0]) < 1)
			PLAYING = FALSE;
	}
		player.score+=player.level; /* 1 point per piece dropped in the pit */
		swabboard();
		new_piece();
		JUSTDROPPED =  TRUE;
	/* kludge to clean board of possible debris */
	for ( i = 0; i < 23 ; i++ )
		for ( j = 0; j < 9 ; j++ )
			if ( playfield[i][j] < 2 )
				playfield[i][j] = NO_BLOCK;

	gl_printf( 230,50,"           "); // more kludge to clean up 
	gl_printf( 230,80,"      "); // old score bits ...
	gl_printf( 230,110,"     ");
	gl_printf( 280-(10*((int)log10((double)player.score))), 50 , "%d", player.score );
	gl_printf( 280-(10*((int)log10((double)player.lines))), 80, "%d", player.lines ); 
	gl_printf( 280-(10*((int)log10((double)player.level))), 110, "%d", player.level ); 
}


void rotate_clock(void)
{
	switch(piece.shapetype)
	{
		case 1: piece.shapetype = 7; // S
			break;
		case 2: piece.shapetype = 8; // Z
			break;
		case 3: piece.shapetype = 9; // I2
			break;
		case 4: piece.shapetype = 12; // T
			break;
		case 5: piece.shapetype = 15; // J
			break;
		case 6: piece.shapetype = 18; // L 
			break;
		case 7: piece.shapetype = 1; // S2
			break;
		case 8: piece.shapetype = 2; // Z2
			break;
		case 9: piece.shapetype = 3; // I2
			break;	
		case 10: piece.shapetype = 4;
			break;
		case 11: piece.shapetype = 10;
			break;
		case 12: piece.shapetype = 11;
			break;
		case 13: piece.shapetype = 5;
			break;
		case 14: piece.shapetype = 13;
			break;
		case 15: piece.shapetype = 14;
			break;
		case 16: piece.shapetype = 6;
			break;
		case 17: piece.shapetype = 16;
			break;
		case 18: piece.shapetype = 17;
			break;
	}	
}


void rotate_counterclock(void)
{
	switch(piece.shapetype)
	{
		case 1: piece.shapetype = 7;
			break;
		case 2: piece.shapetype = 8;
			break;
		case 3: piece.shapetype = 9;
			break;
		case 4: piece.shapetype = 10;
			break;
		case 5: piece.shapetype = 13;
			break;
		case 6: piece.shapetype = 16;
			break;
		case 7: piece.shapetype = 1;
			break;
		case 8: piece.shapetype = 2;
			break;
		case 9: piece.shapetype = 3;
			break;
		case 10: piece.shapetype = 11;
			break;
		case 11: piece.shapetype = 12;
			break;
		case 12: piece.shapetype = 4;
			break;
		case 13: piece.shapetype = 14;
			break;
		case 14: piece.shapetype = 15;
			break;
		case 15: piece.shapetype = 5;
			break;
		case 16: piece.shapetype = 17;
			break;
		case 17: piece.shapetype = 18;
			break;
		case 18: piece.shapetype = 6;
			break;
	}	
}

int get_keys(void)
{
	//keyboard_clearstate();
	if ( keyboard_update() == TRUE )
	{
		if ( keyboard_keypressed(SCANCODE_P) )
		{
			paused();
			return(0);
		}
		if ( keyboard_keypressed(SCANCODE_O) )
		{
			if (SHOW_NEXT) SHOW_NEXT = FALSE;
			else SHOW_NEXT = TRUE;
			return(0);
		}
		if ( keyboard_keypressed(SCANCODE_CURSORBLOCKLEFT) )
			return(-1);	
		if ( keyboard_keypressed(SCANCODE_CURSORBLOCKRIGHT) )	
			return(1);
		if ( keyboard_keypressed(SCANCODE_CURSORBLOCKDOWN) )
			return(32);
		if ( keyboard_keypressed(SCANCODE_A) )
			return(-8);
		if ( keyboard_keypressed(SCANCODE_S) 
			 || keyboard_keypressed(SCANCODE_CURSORBLOCKUP) )
			return(8);
		if ( keyboard_keypressed(SCANCODE_ESCAPE) )
			PLAYING = FALSE;
			
	} 
	return(0); /* to appease the compiler warning gods */
}


void drawonce(void) // called from initfield
{
	int i, j, k, l;

	/* "the pit" */
	vga_setcolor(LIGHT_MAGENTA);
	for ( i = 0; i < 21 ; i++)
		for ( j = 0 ; j <= SCALE ; j++ )
			for ( k = 0 ; k <= SCALE ; k++ )
			{
				vga_drawpixel((OFFSET-1)*SCALE+j,SCALE*(3+i)+k);
				// left and right walls
				vga_drawpixel((OFFSET+10)*SCALE+j, SCALE*(3+i)+k);
			}

	for ( i = 0; i < 12 ; i++ )
		for ( j = 0 ; j <= SCALE ; j++ )
			for ( k = 0 ; k <= SCALE ; k++ )
				vga_drawpixel(SCALE*(i+OFFSET-1)+j, SCALE*23+k );
	
	/* "Next" box */
	gl_printf(33,39,"NEXT"); 
	vga_setcolor(LIGHT_CYAN);
	for ( i = 2; i < 10 ; i++)
		for ( j = 0 ; j <= SCALE ; j++ )
			for ( k = 0 ; k <= SCALE ; k++ )
			{
				vga_drawpixel(i*SCALE+j, 6*SCALE+k );
				vga_drawpixel(i*SCALE+j ,11*SCALE+k);
			}
	for ( i = 6 ; i < 12 ; i++ )
		for ( j = 0 ; j <= SCALE ; j++ )
			for ( k = 0 ; k <= SCALE ; k++ )
	{
		vga_drawpixel( 2*SCALE+j, i*SCALE+k );
		vga_drawpixel( 9*SCALE+j, i*SCALE+k );
	}
	vga_setcolor(BLACK);
	for ( i = 7; i < 11 ; i++ )
		for ( j = 3; j < 9 ; j++ )
			for ( k = 0 ; k <= SCALE ; k++ )
				for ( l = 0 ; l <= SCALE ; l++ )
					vga_drawpixel(j*SCALE+k, i*SCALE+l); 
	/*end Next box */
	/*
	vga_setcolor(LIGHT_RED);
	for ( j = 0 ; j <= SCALE ; j++ )
		for ( k = 0 ; k <= SCALE ; k++ )
		{
			vga_drawpixel( (OFFSET+14)*SCALE+j, 10*SCALE+k );
			vga_drawpixel( (OFFSET+24)*SCALE+j, 10*SCALE+k );
		}
	for ( i = (OFFSET+14); i < (OFFSET+25) ; i++ )
		for ( j = 0 ; j <= SCALE ; j++ )
			for ( k = 0 ; k <= SCALE ; k++ )
	{
		vga_drawpixel( i*SCALE+j, 9*SCALE+k );
		vga_drawpixel( i*SCALE+j, 11*SCALE+k );
	}
	vga_setcolor(YELLOW);
	for ( j = 0 ; j <= SCALE ; j++ )
		for ( k = 0 ; k <= SCALE ; k++ )
		{
			vga_drawpixel( (OFFSET+14)*SCALE+j, 15*SCALE+k );
			vga_drawpixel( (OFFSET+24)*SCALE+j, 15*SCALE+k );
		}
	for ( i = (OFFSET+14); i < (OFFSET+25) ; i++ )
		for ( j = 0 ; j <= SCALE ; j++ )
			for ( k = 0 ; k <= SCALE ; k++ )
			{
				vga_drawpixel( i*SCALE+j, 14*SCALE+k );
				vga_drawpixel( i*SCALE+j, 16*SCALE+k  );
			}

	vga_setcolor(LIGHT_BLUE);
	for ( j = 0 ; j <= SCALE ; j++ )
		for ( k = 0 ; k <= SCALE ; k++ )
		{
			vga_drawpixel( (OFFSET+14)*SCALE+j, 19*SCALE+k );
			vga_drawpixel( (OFFSET+24)*SCALE+j, 19*SCALE+k );
		}
	for ( i = (OFFSET+14); i < (OFFSET+24) ; i++ )
		for ( j = 0 ; j <= SCALE ; j++ )
			for ( k = 0 ; k <= SCALE ; k++ )
			{
				vga_drawpixel( i*SCALE+j, 18*SCALE+k );
				vga_drawpixel( i*SCALE+j, 20*SCALE+k );
			}
	*/
	gl_setfontcolors(BLACK,GREEN);
	gl_printf( 220, 100, "%s","LEVEL" ); 
	gl_printf( 220, 40, "%s", "SCORE" );
	gl_printf( 220,70, "%s", "LINES" ); 
	gl_setfontcolors(BLACK,WHITE);
	gl_printf( 280-(10*((int)log10((double)player.score))), 50 , "%d", player.score );
	gl_printf( 280-(10*((int)log10((double)player.lines))), 80, "%d", player.lines ); 
	gl_printf( 280-(10*((int)log10((double)player.level))), 110, "%d", player.level ); 
}

void draw(void)
{
	int i, j, k, l;
	/* the pit's contents */
	for ( i = 3; i < 23 ; i++ )
		for ( j = 0 ; j < 10 ; j++ )
			if ( playfield[i][j] == FINISHED_BLOCK )
			{ 
			/*	 moved to redraw only on drop
				for ( k = 0 ; k <= SCALE ; k++ )
					for ( l = 0 ; l <= SCALE ; l++ )
				vga_drawpixel( (j+OFFSET)*SCALE+k, SCALE*i+l );
			*/
			}
			else if ( playfield[i][j] == BLOCK )
			{
				for ( k = 0 ; k <= SCALE ; k++ )
					for ( l = 0 ; l <= SCALE ; l++ )
					{
						vga_setcolor(baseshapetype+1);
						if ( ((l == 1 || l == 6) 
						  && (k != 0 && k != 7)) 
						  || ((k == 1 || k == 6)
						  && (l != 0 && l != 7)) )
							vga_setcolor(BLACK);	
						vga_drawpixel( (j+OFFSET)*SCALE+k, i*SCALE+l );
					}
				vga_setcolor(WHITE);
			
			}
			else
			{
			/* experiment with not redrawing NO_BLOCK everytime*/
			
				vga_setcolor(BLACK);
				for ( k = 0 ; k <= SCALE ; k++ )
					for ( l = 0 ; l <= SCALE ; l++ )
							vga_drawpixel( (j+OFFSET)*SCALE+k, i*SCALE+l );
				vga_setcolor(WHITE);

			
			}
	/* Next shape? */
	if (SHOW_NEXT)
		vga_setcolor(mynext.shapetype+1);
	else
		vga_setcolor(0);
	
	for ( i = 0 ; i < 3 ; i++ )
		for ( j = 0 ; j <= SCALE ; j++ )
			for ( k = 0 ; k <= SCALE ; k++ )
		  vga_drawpixel(5*(SCALE+piece.shape[mynext.shapetype][i][1])+j,
				 8*(SCALE+piece.shape[mynext.shapetype][i][0])+k); 
	for ( j = 0 ; j <= SCALE ; j++ )
		for ( k = 0 ; k <= SCALE ; k++ )
			vga_drawpixel( 5*SCALE+j, 8*SCALE+k );// <- root block
	vga_setcolor(WHITE);

}
			


void initfield(void)
{
	int i, j;
	for ( i = 0 ; i < 24 ; i++ )
		for ( j = 0 ; j < 10 ; j++ )
			playfield[i][j] = 0;
	srand(time(0)); /* splooge */	
	memcpy(piece.shape, shapes , sizeof(piece.shape)); // see shapes.h

	/* tossed in here cause I felt like it. */
	player.score = 0;
	player.level = startlevel;
	player.lines = 0;
	piece.vert = 0;
	piece.horiz = 0;
	piece.shapetype = 0;
	piece.shapenum = 1;
	mynext.shapetype = 0;
	mynext.vert = 0;
	mynext.horiz = 0;
	mynext.shapenum = 1;
	new_piece(); // 1st one.
	
	drawonce(); // all the boxes ...

}


void gameover(void)
{
	gl_setfontcolors(BLACK, RED);
	gl_printf(230,12, "GAME  OVER");
	sleep(1);
	while(1) 
	{
		 if ( keyboard_update() == TRUE )
			return;
	}
}


void help(void)
{
	vga_setmode(TEXT);
	printf("gauztris, a cheap svgalib tetris clone\n");	
	printf("--level # (start at level #, faster action, higher scoring\n");
	printf("--help (this message)\n\n");
	printf("Keys: h=counter-clockwise l=clockwise\n");
	printf("	  j=left  k=right  space=down \n");
	printf("	  the arrow keys might work too ...\n");
	exit(-1);
}
